\section{Use case 1: communication-avoiding stencil computations}
\label{sec:repl.5pts}

In this section, we will be interested in computing stencil iterations that will be
detailed in the following paragraphs as the related algorithms provide an
interesting framework to redundant computation.

The following sections detail STF implementations of a 2D five-points
stencil.
Section~\ref{sec:back.stencil} describes a scalable variant of the algorithm that has been in previous works.
Section~\ref{sec:repl.solv.stencil.classical} presents the
implementation of a classical approach. A
communi\-cation-avoiding approach leveraging redundant computation is presented in
Section~\ref{sec:repl.solv.stencil.commavoid}. Both approaches are benchmarked in
Section~\ref{sec:repl.solv.stencil.expe}.

\subsection{Scalable parallel stencil algorithms}
\label{sec:back.stencil}

\citeauthor{d.h.m.y:08}\cite{d.h.m.y:08} propose two communication-avoiding
parallel approaches to improve the scalability of the conventional stencil algorithm.
These approaches reduce the number of messages exchanged by
taking into account the size of the subdomain that is locally computable. In
their Parallel Approach 1 (PA1) this amounts to exchanging cells owned by neighboring
ranks that are up to distance $s$ every $s$ steps. We
recall their PA1 algorithm for the 2D mesh case in
Figure~\ref{alg:pa1}. %We did not adapt their PA2 approach to the 2D case.
When iterating over $i$ steps, the communication latency cost
of the PA1 approach is in the range of
$\mathcal{O}(\sfrac{i}{s})$~\cite{d.h.m.y:08}. The
conventional approach fundamentally corresponds to $s=1$ and may be prone to
synchronization issues. This decrease in latency by a factor of $s$ has to be
weighted against an increase in computational load %in $\mathcal{O}(s^2)$
as each rank in the communication-avoiding approaches replicates the execution of the stencil up to $s$ cells away.
%The
%second approach computes locally available cells as much as it is possible to
%avoid redundant work before exchanging the ``missing'' values with neighbors to
%complete different steps of the local mesh.
%this halo of cells has to be exchanged every $s$ iterations with neighboring ranks.

% cannot use subfigure: caption is not well defined for algorithm so it messes
% with subcaption

%\begin{minipage}{0.49\textwidth}
%	\centering
%	recv $\Omega_{p+1}$[1] from $p+1$
%	send $\Omega_{p}$[-1] to $p+1$
%	recv $\Omega_{p-1}$[-1] from $p-1$
%	send $\Omega_{p}$[1] to $p-1$
%	update $\Omega_{p-1}[-1] \cup \Omega_p \cup \Omega_{p+1}[1]$
%	$K^{\text{(iter)}}_p \gets \Omega_p$
%	}
%	\caption{PA0.}
%	\label{alg:pa0}
%	\end{algorithmic}
%	\vfill
%\end{minipage}
%\begin{minipage}{0.49\textwidth}
%	\centering


\begin{figure}
\begin{algorithmic}[1]
	\FOR{it$=1,s+1,\dots$}
  		% on peut pas faire ça parce que le morceaud d'omega R qu'on récupère il
  		% dépend de x' et y' et ça me fait utiliser des syntaxes étranges
		%\FOR{x'$=x-1,x,x+1$}{
		%\FOR{y'$=y-1,y,y+1$}{
		\STATE recv $\delta\Omega_r$ from at most 8 ranks
			\{$(r\sfrac{+}{-}1,c\sfrac{+}{-}1),(r\sfrac{+}{-}1,c),(r,c\sfrac{+}{-}1)$\}
		%}
		%}
		\FOR{s\_it$=s-1,s-2,s-2,, \dots 0$}
			\STATE update $\Omega_r \cup \delta\Omega_r^{(s\_it)}$
		\ENDFOR
	\ENDFOR
\end{algorithmic}
\caption[PA1 executed from the process of rank $r$.]
	{PA1 executed from the process of rank $r=(r,c)$. Notations are detailed in
  Seciton~\ref{sec:repl.stencil.notat}.}
\label{alg:pa1}
\end{figure}
% \vfill
% \end{minipage}
% 	compute locally available iterations
% 	update $\Omega_p[s\_it:-s\_it]$
% 	$K^{\text{(it+s\_it-1)}}_p \gets \Omega_p[s\_it:-s\_it]$
% 	}
% 	exchange computed iterations
% 	recv $\cup_{k=1}^{\sfrac{s}{2}}K[it+k]_{p+1}[k:k+1]$ from $p+1$
% 	send $\cup_{k=1}^{\sfrac{s}{2}}K[it+k]_{p}[-k-1:-k]$ to $p+1$
% 	recv $\cup_{k=1}^{\sfrac{s}{2}}K[it+k]_{p-1}[-k-1:-k]$ from $p-1$
% 	send $\cup_{k=1}^{\sfrac{s}{2}}K[it+k]_{p}[k:k+1]$ to $p-1$
% 	computing remaining iterations
% 	update $\Omega_p[-s\_it:-1] \cup \Omega_{p+1}[1:s\_it]$
% 	$K^{\text{(it+s\_it-1)}}_p[-s\_it:-1] \gets \Omega_p[-s\_it:-1]$
% 	update $\Omega_p-1[-s\_it:-1] \cup \Omega_{p}[1:s\_it]$
% 	$K^{\text{(it+s\_it-1)}}_p[1:s\_it] \gets \Omega_p[1:s\_it]$
% 	}
% 	update $\Omega_{p-1}[-s+s\_it:-1] \cup \Omega_p \cup \Omega_{p+1}[1:s-s\_it]$
% 	$K^{\text{(it+s\_it-1)}}_p \gets \Omega_p$
% 	}
% 	}
% 	\caption{PA2.}
% 	\label{alg:pa2}
% \end{algorithmic}


% ANNEXE
% The PA1 approach has been studied repeatedly over the 2010s to better
% understand how it lifts the cost of synchronization, especially in the case of
% iterative solvers~\cite{h:10,c.k.d:13}.
% %Such trade-offs are often found in areas of research relying on parallel computation~\cite{b.c.d.hea:14}.
% %While communication-avoiding
% %techniques are promising because they reduce the costs of communication,
% %these techniques may lead to numerical instability~\cite{c:15} that
% %requires further redesign of subspace methods~\cite{c:18}.
% Other techniques such as overlapping communication and computation have been
% studied~\cite{g.a.m.v:13}. The communication-avoiding algorithms have been
% ported to single-node accelerated platforms with success inside the Magma
% library to avoid data transfers to GPU devices~\cite{y.i.a.t.h.d:14}. A large
% portion of the literature has been focused on the productivity of the domain
% experts up to compiler optimizations concerns to abstract away the reordering of
% memory movement between the CPU memory and its registers~\cite{b.v.h.w.ea:13}.
% % iteratively solving systems.
% ANNEXE

%In a distributed-memory setting, the use of runtime systems has been
%extensively explored for the case of simpler algorithms that do not avoid
%communications~\cite{a.g.g.n.r:13,h.k.i:13,b.b.a.c:14,a.a.b.c.p:17,e.j.l.p.p:18}.
%Recent works have been geared toward enabling the communication-avoiding
%approaches in widely-available software stack such as
%Trilinos~\cite{y.t.h.b.s.e:20}.
Regarding general-purpose runtime systems,
PaRSEC has been explored to enable
communication-avoiding techniques through its PTG
interface: the work from \citeauthor{p.c.b.l.e.d:20}\cite{p.c.b.l.e.d:20}
actually tackles similar productivity concerns as the ones addressed in this paper. The main
difference resides in the approaches that are set up: the PTG interface has been used to
implement the communication-avoiding algorithm while the work we present seek to
modify the STF programming model with respect to the class of algorithm it
represents.

\subsubsection{Problem notations}
\label{sec:repl.stencil.notat}

\begin{figure}
\centering
	\begin{tikzpicture}[scale=0.5]
\pgfmathsetmacro{\X}{9}
\pgfmathsetmacro{\Y}{\X}
\pgfmathsetmacro{\P}{3}
\pgfmathsetmacro{\Q}{\P}
\foreach \x in {1,...,\X}{
	\foreach \y in {1,...,\Y}{
		\ifthenelse{\x>3\AND\x<7\AND\y>3\AND\y<7}{
			\node[fill=mygre!40,draw=black,circle] (n-\x-\y) at (\x,\y) {};
		}{
			\ifthenelse{\x>1\AND\x<9\AND\y>2\AND\y<8}{
				\node[fill=myred!40,draw=black,circle] (n-\x-\y) at (\x,\y) {};
			}{
				\ifthenelse{\x>2\AND\x<8\AND\y>1\AND\y<9}{
					\node[fill=myred!40,draw=black,circle] (n-\x-\y) at (\x,\y) {};
				}{
					\node[draw=black,circle] (n-\x-\y) at (\x,\y) {};
				}
			}
		}
	}
}
\foreach \x in {2,...,\X}{
	\foreach \y in {1,...,\Y}{
		\pgfmathsetmacro{\xm}{int(\x-1)}
		\path[draw] (n-\xm-\y) -- (n-\x-\y);
	}
}
\foreach \y in {2,...,\Y}{
	\pgfmathsetmacro{\ym}{int(\y-1)}
	\foreach \x in {1,...,\X}{
		\path[draw] (n-\x-\ym) -- (n-\x-\y);
	}
}
\pgfmathsetmacro{\Qx}{int(\X/\Q)}
\pgfmathsetmacro{\Py}{int(\Y/\P)}
%\foreach \x in {1,...,\P}{
%	\foreach \y in {1,...,\Q}{
%		\pgfmathsetmacro{\i}{int(\Qx-\y-1)}
%		\pgfmathsetmacro{\j}{int(\x-1)}
%		\node[] (l-\x-\y) at (\Qx*\x-1.5,\Py*\y-1.5) {\textbf{(\i,\j)}};
%	}
%}
\pgfmathsetmacro{\Xm}{\X-1}
\pgfmathsetmacro{\Qxp}{2*\Qx}
\foreach \x in {\Qx,\Qxp,...,\Xm}{
	\path[draw,dashed] (\x+0.5,0.5) -- (\x+0.5,\Y+0.5);
}
\pgfmathsetmacro{\Ym}{\Y-1}
\pgfmathsetmacro{\Pyp}{2*\Py}
\foreach \y in {\Py,\Pyp,...,\Ym}{
	\path[draw,dashed] (0.5,\y+0.5) -- (\X+0.5,\y+0.5);
}
\end{tikzpicture}
\caption[Cell 2D block layout.]
{Cell 2D block layout. Green cells are owned by rank (1,1). Red cells are part
of $\delta\Omega_{(1,1)}$, assuming $s=2$. (1,1) retrieves red cells from
neighboring ranks.}
\label{fig:stencil-cell-layout}
\end{figure}

\begin{ab}
  dans la figure~\ref{fig:stencil-cell-layout} il y a des cells rouges
  qui sont à distance 3 des cells vertes. Dans les angles il devrait y
  a voir une seule cell rouge
\end{ab}

The geometric domain $\Omega$ storing the field of values can take different
forms based on the underlying phenomenon that is simulated: in
this work, only 2D structured meshes are considered with each cell having
four neighbors that can be designated with cardinal orientations (north, south,
west, east). The domain $\Omega$ of size $X \times Y$ includes boundary values
that are constant across iterations \emph{i.e.} $\Omega(1,:)$, $\Omega(X,:)$,
$\Omega(:,1)$ and $\Omega(:,Y)$ are not updated.
%This topology means that $A$ is a band matrix however $A$ is
%considered implicitly known \emph{i.e.} no data transfers related to $A$ are
%required among ranks to compute an iteration.
We are interested in computing a simple five-points stencil over the
domain $\Omega$: each cell is updated by computing a function of
itself and its direct neighbors. In the remainder of this document, to
address the distributed-memory setting, a subdomain $\Omega_r$ is
considered as the aggregate of cells owned by rank $r$.
We introduce the notation $\delta\Omega_r^{(d)}$ which is the union of cells at
minimum distance 1 and maximum distance $d$ of $\Omega_r$.
We denote $\delta\Omega_r$, without superscripts, to refer to
$\delta\Omega_r^{(s)}$ where $s$ is the replicating parameter in the
communication-avoiding algorithm.
Assuming
a rank $r$ owns $x \times y$ cells, $\Omega \cup \delta\Omega_r$ contains $(x+s)
\times (y+s)$ cells and $\delta\Omega_r$ alone contains
$(x+2s)(y+2s)-xy-4\frac{s(s-1)}{2}=2s(x+y+1)+2s^2$ cells.
Figure~\ref{fig:stencil-cell-layout} presents a layout of the cells where
$(1,1)$ owns $3 \times 3$ green cells and has to compute an extra $28$ red
cells, assuming $s=2$.
The
distribution of subdomains is often defined according to a 2D Block
layout as to minimize the length-surface ratio (similar to
surface-volume ratio in the 3D case) of the cells owned by different
ranks. A rank $p$ may be designated by its coordinate $(r,c)$ in such a layout.
\begin{ab}
  dans le paragraphe ci-dessus les calculs ne me semblent pas
  corrects. Je dirais plutot:

  Assuming a rank $r$ owns $x \times y$ cells, $\delta\Omega_r$
  contains $2xs+2ys + 4\frac{s(s-1)}{2}$ cells.
  
\end{ab}


\subsection{STF implementation of a classical stencil algorithm}
\label{sec:repl.solv.stencil.classical}

%Various techniques to improve the
%scalability of the operation have been designed on top of the conventional
%approach:
This section aims to present how the STF programming model can be
leveraged to implement the conventional approach. The concerns (granularity,
layout) raised in this section also apply to the communication-avoiding
approach and have to be adapted.

One of the first concerns to address is the granularity of the tasks:
it would be inefficient to submit a task per cell as it results in poor
scaling over a large amount of computing resources. Indeed, updating a cell typically
requires computing only a few flops and the flow of tasks from a sizeable domain $\Omega$
would create a large scheduling overhead. It is, instead, appropriate to
aggregate cells into blocks, \emph{e.g.} of $b \times b$ cells, such
that each task updates all the cells in a block.

In order to simplify the implementation we will consider a static
domain partitioning with blocks of variable size, illustrated in
Figure~\ref{fig:stencil.repl}. Blocks that are internal to a
subdomain, i.e., blocks that can be updated without data owned by
another subdomain, are of size $b\times b$. Instead, blocks that lie
at the interface with another subdomain are smaller and have either
two or four sides of size $s$. This partitioning makes it simple to
retrieve all the ranks that replicate computation over a given block
(it can be stored in a variable \texttt{neigh} for each block) and the
retrieval of adjacent blocks as well as the computation of
$\Omega_r \cup \delta\Omega_r$ both become trivial.
Note that more sophisticated partitioning approaches may be employed
using dynamic partitioning features provided by some runtime systems such as
StarPU; we do not detail such approaches because the main focus
of this study is to validate the capability of the redundant computation feature.

In order to compute the next iterate over the mesh, storing $\Omega$ only once
in a limited memory budget context makes the code more complex. Indeed, each block is updated with the values
of its direct neighbors in the previous iteration. To concurrently
compute a next iterate, these values should be available in-between steps. To
simplify the implementation, we will consider that two grids exist and at each
step one is read and the other is written to then they are swapped.
%


% We will also consider the 2D block irregular layout presented in
% Figure~\ref{fig:stencil.repl} as an additional modification toward
% communication-avoiding approaches. This layout decomposes the subdomain
% owned by a given rank $r$ into blocks of size $s$ if they lie at the interface
% with another rank. Some runtime systems propose dynamic partitioning that
% would allow an implementation to start from a 2D regular layout that can be
% partitioned to get the irregular layout: we do not detail such an implementation.
% The main benefit of the present layout is to make the iteration over blocks
% easier to execute. By assuming that the layout is static and take $s$ into
% account we can easily retrieve
% all the ranks that replicate computation over a given block (it can be stored in
% a variable \texttt{neigh} for each block) and the retrieval of adjacents blocks
% as well as the computation of $\Omega_r \cup \delta\Omega_r$ both become trivial.
%(frontiers of size $1$ are used for the conventional approach algorithm).
%The layout is essentially an irregular 2D block layout. Note
%that this approach does not partition aggressively enough: the blocks of size
%$(s \times s)$ should be triangular. However, the increase in communication
%volume related to these triangular blocks is not so important that it would be a
%practical concern.
%

\begin{figure}
	\centering
	\begin{tikzpicture}[scale=0.8]
		\pgfmathsetmacro{\X}{10}
		\pgfmathsetmacro{\Y}{10}
		\pgfmathsetmacro{\B}{4}
		\pgfmathsetmacro{\s}{0.25}
		\pgfmathsetmacro{\dX}{\B+2*\s}
		\begin{scope}
			\clip (2.5,2.5) rectangle ++(8,8);
		%	\draw[name path global=myXY] (\B,\B) rectangle ++(\B+4*\s,\B+4*\s);
			\fill[myred!20] (\B,\B) rectangle ++(\B+4*\s,\B+4*\s);
			\path[fill=myred!40] (\B+\s,\B) -- ++(\B+2*\s,0) -- ++(\s,\s) --
++(0,\B+2*\s) -- ++(-\s,\s) -- ++(-\B-2*\s,0) -- ++(-\s,-\s) -- ++(0,-\B-2*\s) -- cycle;
			\fill[mygre!30] (\B+\s,\B+\s) rectangle ++(\B+2*\s,\B+2*\s);
			\foreach \x in {0,\dX,...,\X}{
				\foreach \y in {0,\dX,...,\Y}{
					\draw[black,step=1,shift={(\x,\y)}] (-\s,-\s) grid ++(\B+2*\s,\B+2*\s);
					\draw[black,very thick] (\x-\s,\y-\s) rectangle ++(\B+2*\s,\B+2*\s);
				}
			}
		\end{scope}
		\node (o) at (\B+1,\B+2) {\textcolor{mygre}{$\Omega_{(x,y)}$}};
		\node (od) at (\B+3*\s/2+0.5,\B+\s/2)
		{\textcolor{myred}{$\delta\Omega_{(x,y)}$}};
		\draw [gray,decorate,decoration={brace,amplitude=10pt}]
			($(\B+\s,\B+\s) + (0,3*\s+5.75)$) -- ++(\s,0)
			node [black,midway,yshift=0.6cm] {$s$};
		\draw [gray,decorate,decoration={brace,amplitude=10pt}]
			($(\B+\s,\B+\s) + (2+\s,3*\s+5.75)$) -- ++(1,0)
			node [black,midway,yshift=0.6cm] {$b$};
%		\draw [gray,decorate,decoration={brace,amplitude=10pt}]
%			($(\B+\s,\B+\s) + (6.5,0)$) -- ++(0,-\s)
%			node [black,midway,xshift=0.6cm] {$s$};
%		\draw [gray,decorate,decoration={brace,amplitude=10pt}]
%			($(\B+\s,\B+\s) + (6.5,\s+2)$) -- ++(0,-1)
%			node [black,midway,xshift=0.6cm] {$b$};
		\begin{scope}[scale=2,xshift=80,yshift=35]
      \filldraw[gray!20,rounded corners] (0.05,-0.2) rectangle ++(3.7,2.7);
		  \path[draw,myorg,ultra thick,dashed] (1.7,     3.25)      -- (1+1,1+1);
		  \path[draw,myorg,ultra thick,dashed] (1.7-\s/2,3.25-\s/2) -- (1,  1);
		  \path[draw,myorg,ultra thick,dashed] (1.7-\s/2,3.25)      -- (1,  1+1);
		  \path[draw,myorg,ultra thick,dashed] (1.7,     3.25-\s/2) -- (1+1,1);
			\begin{scope}
				\clip (0.6,0.6) rectangle ++(1+0.4*2,1+0.4*2);
			%	\draw[name path global=myxy] (1,1) rectangle ++(1,1);
				\fill[myblu!30,opacity=0.2] (0.75,0.75) rectangle ++(1.5,1.5);
				\fill[white] (1,1) rectangle ++(1,1);
				\fill[myblu!50] (1,0.75) rectangle ++(1,0.25);
				\fill[myblu!50] (1,2) rectangle ++(1,0.25);
				\fill[myblu!50] (0.75,1) rectangle ++(0.25,1);
				\fill[myblu!50] (2,1) rectangle ++(0.25,1);
				\draw[black,step=1] (0,0) grid ++(3,3);
				\node[] (l) at (1.5,1.5) {block};
				\node[] (E) at (2.1,1.5) {E};
				\node[] (W) at (0.9,1.5) {W};
				\node[] (N) at (1.5,2.1) {N};
				\node[] (S) at (1.5,0.9) {S};
			\end{scope}
%			\node[] (l) at (2.8,1.5) {$x+1,y$};
%			\node[] (l) at (0.2,1.8) {$x-1,y$};
%			\node[] (l) at (1.5,2.5) {$x,y+1$};
%			\node[] (l) at (1.5,0.5) {$x,y-1$};
			\node[text width=6cm] (l) at (2,0.4) {\texttt{owner}:
			($x+1,y+1$)};
			\node[text width=6cm] (txt) at (2,0)
				{\texttt{neigh}: $\{(x,y),(x+1,y),(x,y+1)\}$};
		\end{scope}
		\path[draw,myorg,thick] (9,9-\s) --
					(9,9) --
					(9-\s,9) --
					(9-\s,9-\s) -- cycle;
%		\path[draw,myorg,thick] (14.3,  6.6) --
%					(14.3+2,6.6) --
%					(14.3+2,6.6+2) --
%					(14.3,  6.6+2) -- cycle;
	\end{tikzpicture}
	\caption[Layout for communication-avoiding 2D structured stencil algorithm.]
		{Layout for communication-avoiding 2D structured stencil algorithm.
		The subdomain owned by a rank $(x,y)$ is highlighted in green. This rank will
		compute updates over its domain as well as the blocks highlighted in
		red. A block is zoomed-in to clarify what are its neighbors ranks.}
	\label{fig:stencil.repl}
\end{figure}

An STF implementation of the conventional approach, \emph{i.e.} using $s=1$ and
not requiring replication of updates over cells, is presented in
Figure~\ref{code:classical_stencil}. At each iteration the neighbor
blocks at the interface of different ranks have to be
exchanged. Every block $b$ is updated using its neighbors indicated as
$b.\{N,E,W,S\}$. This variant of the 2D five-points stencil is quite
straightforward but incurs in an excessive amount of synchronizations
which can severely limit the scalability.
%In the next sections, the
%possibility to leverage replication, \emph{i.e.} different values of $s$, is
%incorporated inside this expression.

%Our concerns do not lie in
%providing a stencil application that is readily available in an industrial
%setting where optimizing memory consumption would be an important endeavor to
%tackle larger problems. The following section's focus is to showcase the potential of
%replicating tasks.
% and could be obtained
%by declaring a partitioning of blocks -- this detail is omitted from the
%presented Algorithm.

% this is not ok for classical nor CA: just use s=1 to derive classical
% algorithm
%The partitioning is delegated to the runtime which is
%able to decide between using the original data and using any of the children
%partitioning: the user only has to declare the partitioning before its use.
%The partitioning of a subdomain $(x,y)$ is described by
%Figure~\ref{fig:classical_partitioning}: any children partition is simply a
%one-cell row or one-cell column close to the border of the subdomain.

%Figure~\ref{code:classical_stencil} presents an implementation of a classical
%stencil algorithm with the STF model. As the considered mesh is simple (i.e.
%2D, structured, aperiodic), the algorithm is straightforward.% not burdened with complexities.
%The \texttt{update} task specification is uncomplicated: it processes the computation of a block given the
%frontiers of its 4 neighboring blocks. In order to retrieve the cardinal
%frontiers a dynamic partitioning of blocks, declared preliminarily outside the main
%loop, can be delegated to the runtime system.
%% and described in Figure~\ref{fig:classical_partitioning},
%% for dynamic creation of ghosts regions.
%%delivered through the \texttt{frontiers\_around} function.
%
\begin{figure}
\begin{algorithmic}[1]
	\FOR{iter $= 1 \dots$}
		\FOR{block in $\Omega$}
			\STATE insert\_task(update,
				B:\stfRW, \\
%				\begin{ALC@g}
				\{B.N, B.E, B.W, B.S\} :\stfR)
%				\end{ALC@g}
		\ENDFOR
	\ENDFOR
\end{algorithmic}
	\caption{Conventional STF implementation of a five-points stencil.}
	\label{code:classical_stencil}
\end{figure}

%\begin{figure}
%  \centering
%  \begin{tikzpicture}[scale=0.4]
%        \pgfmathsetmacro{\X}{10}
%        \pgfmathsetmacro{\Y}{8}
%        \fill[blue!40] (1,\Y-1) -- (\X-1,\Y-1) -- (\X,\Y) -- (0,\Y) -- cycle;
%        \fill[red!40] (0,0) -- (1,1) -- (\X-1,1) -- (\X,0) -- cycle;
%        \fill[yellow!40] (0,0) -- (0,\Y) -- (1,\Y-1) -- (1,1) -- cycle;
%        \fill[green!40] (\X-1,1) -- (\X-1,\Y-1) -- (\X,\Y) -- (\X,0) -- cycle;
%        \draw[step=1,gray,dashed,ultra thick] (0,0) grid (\X,\Y);
%        \draw[ultra thick] (0,0) -- (\X,0) -- (\X,\Y) -- (0,\Y) -- cycle;
%  \end{tikzpicture}
%  \caption{North-South-West-East partitioning of a subdomain.}
%  \label{fig:classical_partitioning}
%\end{figure}

\subsection{STF implementation of a communication-avoiding stencil algorithm}
\label{sec:repl.solv.stencil.commavoid}

The \textit{communication-avoiding} variant of the classical stencil algorithm
can be expressed using the STF programming model. This section focuses on the
\texttt{PA1} algorithm (see Figure~\ref{alg:pa1}): we will describe how the
baseline and the extended STF programming model can be used to implement it.

\begin{ab}
  ci-dessous on dit ``by checking'' mais je ne vois pas de check dans
  le code.
\end{ab}
Using the baseline STF model results in
Figure~\ref{code:stencil_without_replication}. This algorithm presents
additional loops to set up the replication mechanism explicitly. These
additional loops are used to manage explicitly created copies of
existing handles on all replicating ranks.  Whether a computation
over a block in $\Omega$ should be replicated by a rank $r$ is
verified by checking whether the block is also in
$\Omega_r \cup \delta\Omega_{r}$ \emph{i.e.}  whether it is at
distance up to $s$ from a cell owned by $r$. This condition is easy to
assess in the case of a 2D block layout. The handle that will be used
in the \texttt{update} task by rank $r$ can be denoted $B^{(r)}$, a
replicate of $B$.  In order to get the classical algorithm one can set
$s=1$ -- in this case the explicit copies are bypassed.

\begin{figure}[h]
\begin{algorithmic}[1]
	\FOR{it $= 1, 2, \dots$}
		\IF{it \% s = 1}
			\FOR{B $\in \delta\Omega_r$} % \cup \delta\Omega_r$}
				\FOR{rank in B.\texttt{neigh}}
		\STATE \textcolor{myblu}{
			\stfinsert(copy,B:\stfR,B$^{(rank)}$:\stfRW)
				}
				\ENDFOR
			\ENDFOR
		\ENDIF
		\FOR{B $\in \Omega_r \cup \delta\Omega_r$}
			\STATE local\_B $\gets$ r=B.owner \texttt{?}
			B \texttt{:} B$^{(r)}$
			\STATE insert\_task(update,
				    local\_B:\stfRW,\\
%			\begin{ALC@g}
				\{B.N, B.E, B.W, B.S\} :\stfR)
%			\end{ALC@g}
		\ENDFOR
	\ENDFOR
\end{algorithmic}
	\caption{five-points stencil STF implementation without replication executed by rank $r$.}
	\label{code:stencil_without_replication}
\end{figure}

It is possible to simplify the expression of
Figure~\ref{code:stencil_without_replication} by using the features presented
in Section~\ref{sec:repl.runtime} that form an extended STF programming model.
The resulting expression is provided in
Figure~\ref{code:stencil_with_replication}. In this algorithm we do not use
the \stfinserts wrapper function but rather submit each
\texttt{update} tasks individually using the \stfSAME access mode because
each replicating rank does not modify a given block similarly.
For instance, assume a  block $B$ in $\Omega$ at the interface of two ranks $r$
and $t$: if $r$ owns the block then $r$ naturally needs all
of the neighboring blocks of $B$ to update all the cells in it; however $t$ needs only up to three
of them. For instance $t$ may not require $B.N$ because $B$ is in the northern
region of $\delta\Omega_t$. $t$ would not need to receive $B.N$ because it does
not need to update the top rows of $B$. The situation of the rank $t$ is
exemplified in Figure~\ref{fig:stencil.nullhandles}. Assuming $s=3$ there are
three cases to consider: first, the furthest row/column in $\delta\Omega_t$ is not
updated; second, only the closest row/column in $\delta\Omega_t$ is updated;
third, no cells in $\delta\Omega_t$ are updated.
%This slight difference where a given update task is not strictly duplicated
%across neighboring ranks can be addressed by submitting tasks individually instead
%of relying on \stfinserts.
Thus, tasks modifying a given block are different across ranks: some should
nullify handles that are unnecessary. Every $s$ steps, each rank $r$ should get the
updated values in $\delta\Omega_r$: in order to retrieve these values in, it is
enough to modify the access mode on blocks. Indeed, if the owner of a block uses
a simple \texttt{RW} access mode every $s$ steps -- instead of \texttt{RW+Same}
-- then the runtime will invalidate the extra copies stored by the neighboring
ranks. This will allow the issuing of the transfers upon submitting the next
iteration.

While an additional loop is added to iterate over ranks around any
block, the expression allowed by replicating data write accesses is arguably
simplified compared to the one provided in
Figure~\ref{code:stencil_without_replication}. The proposed implementation
that uses the extension of the STF programming model for replication is more
concise and does not require the user to manage data as precisely: they only
have to be careful of the correctness of their algorithms by telling the runtime
system
when replication does make sense in their application.

%Further details related to the
%implementation of this algorithm within the StarPU runtime system are given in
%Section~\ref{sec:repl.impl-details}.

% An additional partitioning is necessary to enable this algorithm. Moreover, the
% classical partitioning presented in
% Section~\ref{sec:repl.solv.stencil.classical} should be modified. Indeed, as the
% size $s$ of the replicating ring is a parameter of this variant, the
% partitioning is parameterized to replicate only the relevant domains.
% Figure~\ref{fig:stencil_repl_part} shows this actualized partitioning for $s=3$:
% instead of using one-cell row or column, $s$-cell rows or columns are used.

%\begin{figure}[htbp]
%	\centering
%	\begin{subfigure}{0.45\textwidth}
%		\begin{tikzpicture}[scale=0.4]
%            \pgfmathsetmacro{\X}{10}
%            \pgfmathsetmacro{\Y}{8}
%            \pgfmathsetmacro{\s}{3}
%            \fill[blue!40] (\s,\Y-\s) -- (\X-\s,\Y-\s) -- (\X,\Y) -- (0,\Y) -- cycle;
%            \fill[red!40] (0,0) -- (\s,\s) -- (\X-\s,\s) -- (\X,0) -- cycle;
%            \fill[yellow!40] (0,0) -- (0,\Y) -- (\s,\Y-\s) -- (\s,\s) -- cycle;
%            \fill[green!40] (\X-\s,\s) -- (\X-\s,\Y-\s) -- (\X,\Y) -- (\X,0) -- cycle;
%
%	  \fill[red!40] (\X,0) -- (\X,\s) -- (\X-\s,\s) -- (\X-\s,0) -- cycle;
%	  \fill[green!40] (\X,\Y) -- (\X,\Y-\s) -- (\X-\s,\Y-\s) -- (\X-\s,\Y) -- cycle;
%	  \fill[yellow!40] (0,0) -- (0,\s) -- (\s,\s) -- (\s,0) -- cycle;
%	  \fill[blue!40] (0,\Y) -- (0,\Y-\s) -- (\s,\Y-\s) -- (\s,\Y) -- cycle;
%
%	  \fill[pattern={Lines[angle=45,line width=1pt]},pattern
%			color=green!40] (\X,0) rectangle +(-\s,\s);
%	  \fill[pattern={Lines[angle=45,line width=1pt]},pattern color=blue!40]
%			(\X,\Y) rectangle +(-\s,-\s);
%	  \fill[pattern={Lines[angle=45,line width=1pt]},pattern color=red!40]
%			(0,0) rectangle +(\s,\s);
%	  \fill[pattern={Lines[angle=45,line width=1pt]},pattern color=yellow!40]
%			(0,\Y) rectangle +(\s,-\s);
%
%            \draw[step=1,gray,dashed,ultra thick] (0,0) grid (\X,\Y);
%            \draw[ultra thick] (0,0) -- (\X,0) -- (\X,\Y) -- (0,\Y) -- cycle;
%    		\end{tikzpicture}
%  \end{subfigure}
%	\begin{subfigure}{0.45\textwidth}
%    \begin{tikzpicture}[scale=0.4]
%	  \pgfmathsetmacro{\X}{10}
%	  \pgfmathsetmacro{\Y}{8}
%          \pgfmathsetmacro{\s}{3}
%	  \fill[blue!40] (\X,0) -- (\X,\s) -- (\X-\s,\s) -- (\X-\s,0) -- cycle;
%	  \fill[red!40] (\X,\Y) -- (\X,\Y-\s) -- (\X-\s,\Y-\s) -- (\X-\s,\Y) -- cycle;
%	  \fill[yellow!40] (0,0) -- (0,\s) -- (\s,\s) -- (\s,0) -- cycle;
%	  \fill[green!40] (0,\Y) -- (0,\Y-\s) -- (\s,\Y-\s) -- (\s,\Y) -- cycle;
%	  \draw[step=1,gray,dashed,ultra thick] (0,0) grid (\X,\Y);
%	  \draw[ultra thick] (0,0) -- (\X,0) -- (\X,\Y) -- (0,\Y) -- cycle;
%    \end{tikzpicture}
%  \end{subfigure}
%
%  \caption{North-South-West-East (left) and NW-NE-SW-SE (right) partitionings of a subdomain.}
%  \label{fig:stencil_repl_part}
%\end{figure}

\begin{figure}
\begin{algorithmic}[1]
	\FOR{it $= 1, 2, \dots$}
		\FOR{B in $\Omega \cup \delta\Omega_r$}
			\FOR{rank $\in$ \{B.\texttt{neigh},B.\texttt{owner}\}}
				\STATE mode $\gets$ \stfRW
				\IF{it \% s = 0 \textbf{and} rank = B.\texttt{owner}}
				\STATE mode $\gets$ mode \texttt{+} \textcolor{myblu}{\stfSAME}
				\ENDIF
				\STATE insert\_task(
					    update,
					    \stfONRANK:rank,\\
					    B:mode, \\
%				\begin{ALC@g}
					    \{B.N, B.E, B.W, B.S\} :\stfR)
%				\end{ALC@g}
			\ENDFOR
		\ENDFOR
	\ENDFOR
\end{algorithmic}
	\caption{five-points stencil STF implementation \textbf{with replication} executed by rank $r$.}
	\label{code:stencil_with_replication}
\end{figure}

%The differences translate in the
%DAG produced for the two implementations, as presented in
%Figure~\ref{fig:dag.stencil.ca}. Further details are exposed in
%Section~\ref{sec:app.stencil}, especially regarding the selection of the
%partitioning for any subdomain $(x,y)$.
%
%\begin{figure}
%\centering
%\begin{tikzpicture}
%	\def\icol{myblu}
%	\def\wcol{mygre}
%	\def\pcol{myred}
%	\def\ccol{gray60}
%	\pgfmathsetmacro{\d}{2}
%	\pgfmathsetmacro{\hd}{1.6}
%	\pgfmathsetmacro{\Hd}{1.1}
%
%	\node[circle,ultra thick,draw=\icol!30!black,fill=\icol] (initA1) 	at (0,0) 			{$\Omega_1$};
%	\node[circle,ultra thick,draw=\icol!30!black,fill=\wcol] (i1W1)  	at ([yshift=-\d cm]initA1) 	{$\Omega_1$};
%	\node[circle,ultra thick,draw=\icol!30!black,fill=\wcol] (i1W1w) 	at ([xshift=\d cm]i1W1)  	{$\Omega_2^W$};
%	\node[circle,ultra thick,draw,fill=\ccol] (r2) 		at ([yshift=\hd cm]i1W1w) 	{$\Omega_2^W$};
%	\node[circle,ultra thick,draw=\wcol!30!black,fill=\wcol] (i2W1)  	at ([yshift=-\d cm]i1W1) 	{$\Omega_1$};
%	\node[circle,ultra thick,draw=\wcol!30!black,fill=\wcol] (i2W1w) 	at ([yshift=-\d cm]i1W1w) 	{$\Omega_2^W$};
%
%	\node[circle,ultra thick,draw,fill=\icol] (initA2) 	at ([xshift=8cm]initA1) {$\Omega_2$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i1W2)  	at ([yshift=-\d cm]initA2)	{$\Omega_2$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i1W2w) 	at ([xshift=-\d cm]i1W2)  	{$\Omega_1^E$};
%	\node[circle,ultra thick,draw,fill=\ccol] (r1) 		at ([yshift=\hd cm]i1W2w){$\Omega_1^E$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i2W2)  	at ([yshift=-\d cm]i1W2) 	{$\Omega_2$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i2W2w) 	at ([yshift=-\d cm]i1W2w)	{$\Omega_1^E$};
%
%	\path[draw,-latex] (initA1) -- (i1W1);
%	\path[draw,-latex] (i1W1) -- (i2W1);
%	\path[draw,-latex] (i1W1w) -- (i2W1w);
%	\path[draw,-latex] (initA2) .. controls([yshift=\Hd cm]r1) .. (r2);
%	\path[draw,-latex] (r2) -- (i1W1w);
%	\path[draw,-latex] (r2) -- (i1W1);
%	\path[draw,-latex] (i1W1w) -- (i2W1);
%
%	\path[draw,-latex] (initA2) -- (i1W2);
%	\path[draw,-latex] (i1W2) -- (i2W2);
%	\path[draw,-latex] (i1W2w) -- (i2W2w);
%	\path[draw,-latex] (initA1) .. controls([yshift=\Hd cm]r2) .. (r1);
%	\path[draw,-latex] (r1) -- (i1W2w);
%	\path[draw,-latex] (r1) -- (i1W2);
%	\path[draw,-latex] (i1W2w) -- (i2W2);
%\end{tikzpicture}
%\caption[Directed Acyclic Graph generated for a 2D structured stencil (without
%replication feature) ]
%{Directed Acyclic Graph generated for a 2D structured stencil
%where green tasks are stencil updates, blue tasks are initialization tasks and
%grey tasks are explicit duplication tasks. The global domain $\Omega$ is divided
%into $\Omega_1$ and $\Omega_2$ each owned by a different rank.}
%\label{fig:dag.stencil.ca}
%\end{figure}
%
%\begin{figure}
%\centering
%\begin{tikzpicture}
%	\def\icol{myblu}
%	\def\wcol{mygre}
%	\def\pcol{myred}
%	\def\ccol{gray60}
%	\pgfmathsetmacro{\d}{2}
%	\pgfmathsetmacro{\hd}{1.6}
%	\pgfmathsetmacro{\Hd}{1.1}
%
%	\node[circle,ultra thick,draw=\icol!30!black,fill=\icol] (initA1) 	at (0,0) 			{$\Omega_1$};
%	\node[circle,ultra thick,draw=\icol!30!black,fill=\wcol] (i1W1)  	at ([yshift=-\d cm]initA1) 	{$\Omega_1$};
%	\node[circle,ultra thick,draw=\icol!30!black,fill=\wcol] (i1W1w) 	at ([xshift=\d cm]i1W1)  	{$\Omega_2^W$};
%	\node[circle,dashed,ultra thick,draw=\pcol!80,fill=\pcol!60] (r2) 		at ([yshift=\hd cm]i1W1w) 	{$\Omega_2^W$};
%	\node[circle,ultra thick,draw=\wcol!30!black,fill=\wcol] (i2W1)  	at ([yshift=-\d cm]i1W1) 	{$\Omega_1$};
%	\node[circle,ultra thick,draw=\wcol!30!black,fill=\wcol] (i2W1w) 	at ([yshift=-\d cm]i1W1w) 	{$\Omega_2^W$};
%
%	\node[circle,ultra thick,draw,fill=\icol] (initA2) 	at ([xshift=8cm]initA1) {$\Omega_2$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i1W2)  	at ([yshift=-\d cm]initA2)	{$\Omega_2$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i1W2w) 	at ([xshift=-\d cm]i1W2)  	{$\Omega_1^E$};
%	\node[circle,dashed,ultra thick,draw=\pcol!80,fill=\pcol!60] (r1) 		at ([yshift=\hd cm]i1W2w){$\Omega_1^E$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i2W2)  	at ([yshift=-\d cm]i1W2) 	{$\Omega_2$};
%	\node[circle,ultra thick,draw,fill=\wcol] (i2W2w) 	at ([yshift=-\d cm]i1W2w)	{$\Omega_1^E$};
%
%	\path[draw,-latex] (initA1) -- (i1W1);
%	\path[draw,-latex] (i1W1) -- (i2W1);
%	\path[draw,-latex] (i1W1w) -- (i2W1w);
%	\path[draw,dashed,-latex] (initA2) .. controls([yshift=\Hd cm]r1) .. (r2);
%	\path[draw,-latex] (r2) -- (i1W1w);
%	\path[draw,-latex] (r2) -- (i1W1);
%	\path[draw,-latex] (i1W1w) -- (i2W1);
%
%	\path[draw,-latex] (initA2) -- (i1W2);
%	\path[draw,-latex] (i1W2) -- (i2W2);
%	\path[draw,-latex] (i1W2w) -- (i2W2w);
%	\path[draw,dashed,-latex] (initA1) .. controls([yshift=\Hd cm]r2) .. (r1);
%	\path[draw,-latex] (r1) -- (i1W2w);
%	\path[draw,-latex] (r1) -- (i1W2);
%	\path[draw,-latex] (i1W2w) -- (i2W2);
%\end{tikzpicture}
%\caption[Directed Acyclic Graph generated for a 2D structured stencil (with
%replication feature)]
%{Directed Acyclic Graph generated for a 2D structured stencil
%where green tasks are stencil updates, blue tasks are initialization tasks and
%red tasks are implicit partition tasks. The global domain $\Omega$ is divided
%into $\Omega_1$ and $\Omega_2$ each owned by a different rank.}
%\label{fig:dag.stencil.ca}
%\end{figure}

\subsection{Experiments}
\label{sec:repl.solv.stencil.expe}

In this section, we compare implementation of the 2D five-points stencil
communi\-cation-avoiding approach. This implementation was achieved
using the StarPU runtime system. The proposed extension to enable 
redundant computation %data write replication 
has been added to the runtime in an experimental
branch of its \texttt{git} repository\footnote{the code is available
  online at
  \url{https://gitlab.inria.fr/starpu/starpu/-/merge_requests/68}}: the
\stfSAME access mode has been added and the cache mechanism
adapted to support alternative sources. Our experimental setup uses one
rank per computing node and one worker thread per computing core.

% The algorithms presented in Section~\ref{sec:repl.5pts} assume that the
% computation over any block $b$ is strictly the same for all of $b$'s neighbors.
% This hypothesis is not verified in practice because for blocks at the interface
% of ranks the rank that owns the block will update it fully and other ranks will
% only partially update it. Nonetheless, the access mode $Same$ is helpful toward
% allowing replication: instead of using the wrapper function
% \stfinserts, each individual task is inserted explicitly. For each
% rank involved in the task, unnecessary frontiers are replaced with dummy
% variables. Because the current iteration $it$ and the parameter $s$ can be passed
% down as arguments to tasks along the block $b$, ranks that do not own $b$ can
% easily update the relevant $s - it\%s$ rows and/or columns of a block based on
% what cardinal blocks are available.

In our application, no actual computation is executed. In order to mimic tasks
duration, %reflect the behavior of a real application,
tasks sleep for a given time which is passed as
an argument to the task. The value of this time is modified such that
the interaction between the arithmetic intensity of the stencil operation and
the scalability of the various DAG submission approaches can be assessed. The
duration of a task is a linear function of the number of cells in the block that needs to be
updated. Given a rank $r$ and a block $B$ at the $i$-th step using the
communication-avoiding algorithm with parameter $s$, the computation is as
follows
\begin{itemize}
\item $B$ is owned by $r$ then $r$ updates all the cells in $B$.
\item $B$ is not owned by $r$ and $r$ owns one block adjacent to $B$ then $r$ updates $b * i \% s$ cells.
\item $B$ is not owned by $r$ and $r$ owns no block adjacent to $B$ then $r$ updates $i \% s * i \% s$ cells.
\end{itemize}

\begin{figure}
\centering
\begin{subfigure}{0.32\columnwidth}
	\centering
	\begin{tikzpicture}[scale=0.6]
	\pgfmathsetmacro{\Xm}{-5}
	\pgfmathsetmacro{\Xp}{3}
	\pgfmathsetmacro{\Ym}{-3}
	\pgfmathsetmacro{\Yp}{5}
	\pgfmathsetmacro{\pad}{2}
	\pgfmathsetmacro{\s}{2}

	\pgfmathsetmacro{\I}{1}
	\pgfmathsetmacro{\ii}{int(3-\I+1)}
	% use 1, 2 and 3
	\pgfmathsetmacro{\Xmp}{\Xm+\s}
	\pgfmathsetmacro{\Ymp}{\Ym+\s}
	\pgfmathsetmacro{\sp}{int(\s+1)}
	\pgfmathsetmacro{\sm}{int(\s-1)}

	\begin{scope}

		\clip (-3.3,-\s*5/4-0.1) rectangle (\s*5/4-1.2,\s*7/4-0.8);

%		% between r and t
		\foreach \x in {\Xm,\Xmp,...,\Xp}{
			\foreach \y in {\Ym,\Ymp,...,\Yp}{
		\pgfmathsetmacro{\xx}{int(\x)}
		\pgfmathsetmacro{\yy}{int(\y)}
		\def\col{white}
		\ifthenelse{\xx>-\s\AND\yy<\s}{
			\def\col{myred!60}
		}{}
		\ifthenelse{\xx>0\AND\yy<0}{
			\def\col{mygre!60}
		}{}
		\foreach \dx [count=\ix] in {0.33,1,1.67}{
			\foreach \dy [count=\iy] in {0.33,1,1.67}{
		\ifthenelse{\xx>-\sm\AND\yy=\sm\AND\iy<\ii}{
			\def\col{myred}
		}{}
		\ifthenelse{\xx=-\sm\AND\yy<\sm\AND\ix>\I}{
			\def\col{myred}
		}{}
		% bad formula works only here
		\ifthenelse{\xx=-\sm\AND\yy=\sm\AND\ix>\I\AND\iy<\ii\AND\ix>\iy}{
			\def\col{myred}
		}{}
		\ifthenelse{\xx=-\sm\AND\yy=\sm\AND\ix<\iy}{
			\def\col{myred!20}
		}{}
		\node[draw,fill=\col,circle,inner sep=0pt,minimum size = 7pt]
			(n-\x-\y) at (-1+\x+\dx,-1+\y+\dy) {}; %\ix \iy};
			}
		}
			}
		}
		\path[dashed,ultra thick,draw] (\Xm,0) -- (\Xp,0);
		\path[dashed,ultra thick,draw] (0,\Ym) -- (0,\Yp);
		\path[dashed,draw] (\Xm,\s) -- (\Xp,\s);
		\path[dashed,draw] (\Xm,-\s) -- (\Xp,-\s);
		\path[dashed,draw] (\s,\Ym) -- (\s,\Yp);
		\path[dashed,draw] (-\s,\Ym) -- (-\s,\Yp);
		%% big through r and t
		%\node[] (ot) at (\s/3,-\s/2-1/3) {\small\color{mygre} $\Omega_t$};
		%\node[] (dot) at (-\s/3,-\s/2-1/3) {\small\color{myred} $\delta\Omega_t$};
	\end{scope}

	\pgfmathsetmacro{\ii}{int(Mod(int(3-\I),3))}
	\node[] (it) at (-1.0,-3.5) {(s - it) \% s = \ii};%{"$1 + (it \mi 1 \% s) \eq 1$"}};

	\end{tikzpicture}
\end{subfigure}
\begin{subfigure}{0.32\columnwidth}
	\centering
	\begin{tikzpicture}[scale=0.6]
	\pgfmathsetmacro{\Xm}{-5}
	\pgfmathsetmacro{\Xp}{3}
	\pgfmathsetmacro{\Ym}{-3}
	\pgfmathsetmacro{\Yp}{5}
	\pgfmathsetmacro{\pad}{2}
	\pgfmathsetmacro{\s}{2}

	\pgfmathsetmacro{\I}{2}
	% use 1, 2 and 3
	\pgfmathsetmacro{\Xmp}{\Xm+\s}
	\pgfmathsetmacro{\Ymp}{\Ym+\s}
	\pgfmathsetmacro{\sp}{int(\s+1)}
	\pgfmathsetmacro{\sm}{int(\s-1)}

	\begin{scope}

		\clip (-3.3,-\s*5/4-0.1) rectangle (\s*5/4-1.2,\s*7/4-0.8);

		% between r and t
		\foreach \x in {\Xm,\Xmp,...,\Xp}{
			\foreach \y in {\Ym,\Ymp,...,\Yp}{
				\pgfmathsetmacro{\xx}{int(\x)}
				\pgfmathsetmacro{\yy}{int(\y)}
				\def\col{white}
				\ifthenelse{\xx>-\s\AND\yy<\s}{
					\def\col{myred!60}
				}{}
				\ifthenelse{\xx>0\AND\yy<0}{
					\def\col{mygre!60}
				}{}
				\foreach \dx [count=\ix] in {0.33,1,1.67}{
					\foreach \dy [count=\iy] in {0.33,1,1.67}{
		\pgfmathsetmacro{\ii}{int(3-\I+1)}
		\ifthenelse{\xx>-\sm\AND\yy=\sm\AND\iy<\ii}{
			\def\col{myred}
		}{}
		\ifthenelse{\xx=-\sm\AND\yy<\sm\AND\ix>\I}{
			\def\col{myred}
		}{}
%		\ifthenelse{\xx=-\sm\AND\yy=\sm\AND\ix>\I\AND\iy<\ii\AND\ix>\iy}{
%			\def\col{myred}
%		}{}
		\ifthenelse{\xx=-\sm\AND\yy=\sm\AND\ix<\iy}{
			\def\col{myred!20}
		}{}
		\node[draw,fill=\col,circle,inner sep=0pt,minimum size = 7pt]
			(n-\x-\y) at (-1+\x+\dx,-1+\y+\dy) {};
					}
				}
			}
		}
		\path[dashed,ultra thick,draw] (\Xm,0) -- (\Xp,0);
		\path[dashed,ultra thick,draw] (0,\Ym) -- (0,\Yp);
		\path[dashed,draw] (\Xm,\s) -- (\Xp,\s);
		\path[dashed,draw] (\Xm,-\s) -- (\Xp,-\s);
		\path[dashed,draw] (\s,\Ym) -- (\s,\Yp);
		\path[dashed,draw] (-\s,\Ym) -- (-\s,\Yp);
		%% big through r and t
		%\node[] (ot) at (\s/3,-\s/2-1/3) {\small\color{mygre} $\Omega_t$};
		%\node[] (dot) at (-\s/3,-\s/2-1/3) {\small\color{myred} $\delta\Omega_t$};
	\end{scope}

	\pgfmathsetmacro{\ii}{int(Mod(int(3-\I),3))}
	\node[] (it) at (-1.0,-3.5) {(s - it) \% s = \ii};%{"$1 + (it \mi 1 \% s) \eq 1$"}};

	\end{tikzpicture}
\end{subfigure}
\begin{subfigure}{0.32\columnwidth}
	\centering
	\begin{tikzpicture}[scale=0.6]
	\pgfmathsetmacro{\Xm}{-5}
	\pgfmathsetmacro{\Xp}{3}
	\pgfmathsetmacro{\Ym}{-3}
	\pgfmathsetmacro{\Yp}{5}
	\pgfmathsetmacro{\pad}{2}
	\pgfmathsetmacro{\s}{2}

	\pgfmathsetmacro{\I}{3}
	% use 1, 2 and 3
	\pgfmathsetmacro{\Xmp}{\Xm+\s}
	\pgfmathsetmacro{\Ymp}{\Ym+\s}
	\pgfmathsetmacro{\sp}{int(\s+1)}
	\pgfmathsetmacro{\sm}{int(\s-1)}

	\begin{scope}

		\clip (-3.3,-\s*5/4-0.1) rectangle (\s*5/4-1.2,\s*7/4-0.8);

		% between r and t
		\foreach \x in {\Xm,\Xmp,...,\Xp}{
			\foreach \y in {\Ym,\Ymp,...,\Yp}{
				\pgfmathsetmacro{\xx}{int(\x)}
				\pgfmathsetmacro{\yy}{int(\y)}
				\def\col{white}
				\ifthenelse{\xx>-\s\AND\yy<\s}{
					\def\col{myred!60}
				}{}
				\ifthenelse{\xx>0\AND\yy<0}{
					\def\col{mygre!60}
				}{}
				\foreach \dx [count=\ix] in {0.33,1,1.67}{
					\foreach \dy [count=\iy] in {0.33,1,1.67}{
		\pgfmathsetmacro{\ii}{int(3-\I+1)}
		\ifthenelse{\xx>-\sm\AND\yy=\sm\AND\iy<\ii}{
			\def\col{myred}
		}{}
		\ifthenelse{\xx=-\sm\AND\yy<\sm\AND\ix>\I}{
			\def\col{myred}
		}{}
		\ifthenelse{\xx=-\sm\AND\yy=\sm\AND\ix>\I\AND\iy<\ii\AND\ix>\iy}{
			\def\col{myred}
		}{}
		\ifthenelse{\xx=-\sm\AND\yy=\sm\AND\ix<\iy}{
			\def\col{myred!20}
		}{}
		\node[draw,fill=\col,circle,inner sep=0pt,minimum size = 7pt]
			(n-\x-\y) at (-1+\x+\dx,-1+\y+\dy) {};
					}
				}
			}
		}
		\path[dashed,ultra thick,draw] (\Xm,0) -- (\Xp,0);
		\path[dashed,ultra thick,draw] (0,\Ym) -- (0,\Yp);
		\path[dashed,draw] (\Xm,\s) -- (\Xp,\s);
		\path[dashed,draw] (\Xm,-\s) -- (\Xp,-\s);
		\path[dashed,draw] (\s,\Ym) -- (\s,\Yp);
		\path[dashed,draw] (-\s,\Ym) -- (-\s,\Yp);
		%% big through r and t
		%\node[] (ot) at (\s/3,-\s/2-1/3) {\small\color{mygre} $\Omega_t$};
		%\node[] (dot) at (-\s/3,-\s/2-1/3) {\small\color{myred} $\delta\Omega_t$};
	\end{scope}

	\pgfmathsetmacro{\ii}{int(Mod(int(3-\I),3))}
	\node[] (it) at (-1.0,-3.5) {(s - it) \% s = \ii};%{"$1 + (it \mi 1 \% s) \eq 1$"}};

	\end{tikzpicture}
\end{subfigure}
\caption[Communication-avoiding irregular update tasks.]
{ The green cells in $\Omega_t$ are owned by $t$ and updated
every step.
When $t$ updates blocks in $\delta\Omega_t$, not all cells in these
blocks are updated ; only dark-red cells are. Pale red cells are not updated
nor read but are still transferred because they are part of the same block as
the glowing red cells.
At each step, one row/column
less is updated until, every $s$ steps, $\delta\Omega_t$ is fetched from its
owners with updated values. Assuming $s=3$ and every $s$ steps ; \textbf{Left:}
the first iteration $s-1=2$ rows/columns are updated. \textbf{Center:} the
second iteration $s-2=1$ rows/columns are updated. \textbf{Right:} the $s$-th
iteration $s-s=0$ no cells are updated.}
\label{fig:stencil.nullhandles}
\end{figure}

To compute the speed of the operation, we assume that a single cell takes 9 Flop to be
updated similarly to \citeauthor{p.c.b.l.e.d:20}~\cite{p.c.b.l.e.d:20}. Thus, updating a block of size
$m \times n$ takes $9mn$ Flop. In our benchmark, the minimum time to process a cell is
denoted $t_c$ and it is a tunable parameter of our experiments. The
attainable peak performance by one core is denoted $p_c=\sfrac{9}{t_c}$. If $i$
iterations over a mesh of size $X \times Y$ take $t$ to complete, then the
computation speed will be $p=i\frac{9XY}{t}$ and the utilization percentage of
the machine, equipped with $c$ cores, is $\frac{p}{c p_c}$. We use
two CPU-only platforms to perform the benchmarks. The first platform is
Ir\`ene-Rome which is composed of 2,292 compute nodes interconnected through
Infiniband HDR100 and equipped with \href{https://en.wikichip.org/wiki/amd/epyc/7h12}{AMD Rome 7H12 \@ 2.6 GHz} dual-processors and 256GB of DDR4 RAM.
The second platform is Ir\`ene-Skylake which is composed of 1,656 compute nodes
unterconnected through Infiniband EDR and equipped with \href{https://en.wikichip.org/wiki/intel/xeon_platinum/8168}{Intel Skylake 8168 \@ 2.7 GHz}
dual-processors and 192GB of DDR4 RAM. These two platforms differs by their
respective number of cores per node (128 for Rome, 48 for Skylake) which impact
the overall architecture of the compute node such as the number of NUMA nodes.

%\todoaj{
%le message que je vois par rapport aux dernieres expes:
%+ le parametre s est grand - on communique souvent donc on passe mieux a
%l'echelle
%
%si on decompose l'appli en phase de calcul/comms, si le poids des 2 etapes est
%equivalent alors mieux utiliser la bande passante est bon parce que 2 etapes de
%comms s'enchainent de maniere fluide
%
%en revanche si les 2 etapes sont completements differentes l'impact sur la
%scalabilite n'est pas le meme
%
%si les calculs ne pesent pas lourds du tout dans l'application alors peut etre
%que l'architecture n'est pas adapte: utiliser mieux les ressources en mettant
%moins de coeurs, etc. ; en tout cas, densifier le calcul en faisant moins de
%messages est une possibilite qui marche
%
%si les calculs pesent tres lourds alors l'optimisation sur les message n'est pas
%tres importante: la scalabilite ne peut pas etre amelioree par cette seule
%technique
%
%}

%For each implementation, weak scalability is assessed: for each core, there
%should exist 4 subdomains that needs to be processed. The global subdomain size
%is chosen such that the computing load is evenly distributed across ranks. The
%grid of ranks is square such that it minimizes the interfaces between ranks,
%thus minimizing the global communication volume over the network. Three
%parameters are explored: the processing time of a cell, the number of iterations
%and the size of the replicating ring. For each task, the size of the subdomain
%to update is clearly defined therefore it is possible to let the task occupy
%a given time range. The number of iterations can be easily selected, as is the
%size of the replicating ring.
%
%In this section, we only report performance measurement as the throughput -- the
%number of iterations per second. The communication volume has also been
%evaluated over smaller test cases to ensure the correctness of the
%implementation: the observed volume match with the theory \emph{i.e.} each
%implementation exchanges the same amount of data over a different number of
%messages.

Figure~\ref{fig:stencil.exp.comms} presents the volume of
communication as the number of iteration increases for a mesh of size $1152
\times 1152$ using $8 \times 8$ processes with $b=6$.
This shows how the communication-avoiding variant behave at runtime compared to
the conventional approach. From this
figure, it is clear that the latency is more impactful on the conventional
approach because it sends messages at each iteration.
%It is also clear that
%bandwidth is under more stress from the communication-avoiding variant:
For the communication-avoiding variant, communication volume plateaus for $s$ steps and between each plateau the gap is
wider as $s$ increases. We can observe a small discrepancy between all the
variants as $s$ increase. This comes from the fact that the exchanged subdomains
$\delta\Omega$ are not trimmed at the edges: some useless cells are transferred
because the blocks are rectangular despite the required regions being triangular.
This overhead corresponds to $\mathcal{O}(s^2/2)$ cells sent up to 4 times each $s$
iteration for each rank. We consider
this gap to be negligible in our experiments but real applications might find it
worth the effort to implement the packing and unpacking of arrays that describe
the triangular blocks. This gap is further increased by the initial
conditions that are aggregated into blocks as well: although they remain unchanged
across iterations, they still have to be exchanged once at the first iteration.
%Boundary conditions ary are not targeted by the flush mechanism when it is invoked.

\begin{figure}
	\centering
	\includegraphics[width=\columnwidth]{{figures/stencil.comms}.pdf}
	\caption[Communication volume for conventional and
		communication-avoiding approaches for a 2D five-points stencil.]
	{Communication volume along iterations evaluating conventional ($s = 1$)
	and communication-avoiding ($s > 1$) approaches for a 2D five-points
stencil over a $8 \times 8$ grid of 64 MPI ranks.
	Lines represent total communication volume. Bars represent
communication volume during the $i^{\text{th}}$ iteration.}
	\label{fig:stencil.exp.comms}
\end{figure}

Figure~\ref{fig:stencil.exp.scala} presents performance results for 38 iterations
in strong scalability. The problem size is fixed for all number of cores.
The conventional approach is compared with the
communication-avoiding approaches taking 3 values for the $s$ parameter: 4, 16
and 38. Each value is only a small percentage of a block of
size $1024$. We have selected several $t_c$ to test the robustness of approach
with regard to this parameter. The selected values make it possible to go from a
regime where tasks are fast and the machine is hardly utilized to a more
efficient regime where tasks are relatively slow. These regimes can match actual
computation in the literature as some interactions between cells can be very
arithmetically intensive.
%Indeed the peak performance of a
%Platform~\ref{exp:rome}'s cores is about 40 GFlop/s which would require a single
%cell to be computed in $\sfrac{9}{40*10^9} = 0.22ns$. For Platform~\ref{exp:skylake}
%with cores performing about 80GFlop/s, this would mean a cell is processed in
%$0.11ns$.
We observe that the conventional approach is less scalable than the
communication-avoiding one. With $s$ sufficiently high (a small percentage of
the block size%about the number of iterations
) fewer messages are exchanged and the scalability is increased.
We also observe that when a kernel is taking longer then the achievable
scalability is improved which is expected because it naturally leads to an
easier overlap of computations and communications.

\begin{figure}
	\centering
	\includegraphics[width=\columnwidth]{{figures/stencil.strong}.pdf}
	\caption{Strong scalability experiment evaluating classical and
communication-avoiding approaches on a 2D five-points stencilfor stencil.}
	\label{fig:stencil.exp.scala}
\end{figure}

Figure~\ref{fig:stencil.exp.param} shows different values of the parameter
$s$ in a specific scenario using 36 Skylake computing nodes. In this scenario
where the number of iterations is far larger than the size of the blocks, we can
assess the importance of tuning $s$. We observe that up to $s=32=b/32$
it is beneficial to increment $s$. Past this threshold increasing $s$
yields diminishing returns. This behavior is expected since the amount of
additional work that is replicated for a given rank is, not considering rank
close to the borders of the domain, $(\frac{Y}{p}+2s)(\frac{X}{q}+2s) -
\frac{XY}{pq} \sim 2s^2 + 2s(\sfrac{X}{q}+\sfrac{Y}{p})$. With the latency improved by $\mathcal{O}(s)$
and the overall bandwidth unchanged
%-- discounting triangular subdomain of size $s \times s$ as well as initial conditions --
the increased computational workload has to be responsible for some overhead when $s$ is too large.
%Note that while the implementation has been presented through an irregular 2D
%block layout, the actual implementation retrieves the irregular pattern by
%submitting a partioning of $\Omega$ thus a block is at most of size $b \times b$
%and irregular blocks have size $s \% b \times s$, $b \times s \% b$ or $ s \% b
%\times s \% b$.

\begin{figure}
	\centering
	\includegraphics[width=0.6\columnwidth]{{figures/stencil.S}.pdf}
	\caption{Different values of $s$ for the communication-avoiding five-points
	stencil.}
	\label{fig:stencil.exp.param}
\end{figure}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "submission"
%%% TeX-command-extra-options: "-shell-escape --enable-write18 --synctex=1"
%%% jinx-languages: "en"
%%% End:
